#!/bin/csh
#		$Id: job07.csh,v 1.8 2007/02/07 16:27:55 remko Exp $
#		GMT EXAMPLE 07
#
# Purpose:	Make a basemap with earthquakes and isochrons etc
# GMT progs:	pscoast, pstext, psxy
# Unix progs:	$AWK, echo, rm

#
#set datadir = /home/markreed/ncfmp/HBL/runs/1996_Fran_long/ww3/snp
set datadir = /home/markreed/ncfmp/HBL/runs/2005_Ophelia_bb/ww3/snp
set origdir = `pwd`

cd $datadir
foreach filename ( \
# Ophelia \
    2005_Ophelia_bb_ww3_??_??_05_??_00.snp \
#     2005_Ophelia_bb_ww3_??_??_05_00_00.snp \
#     2005_Ophelia_bb_ww3_??_??_05_04_00.snp \
#     2005_Ophelia_bb_ww3_??_??_05_08_00.snp \
#     2005_Ophelia_bb_ww3_??_??_05_12_00.snp \
#     2005_Ophelia_bb_ww3_??_??_05_16_00.snp \
#     2005_Ophelia_bb_ww3_??_??_05_20_00.snp \
# Fran \
#     1996_Fran_long_ww3_??_??_96_00_00.snp \
#     1996_Fran_long_ww3_??_??_96_04_00.snp \
#     1996_Fran_long_ww3_??_??_96_08_00.snp \
#     1996_Fran_long_ww3_??_??_96_12_00.snp \
#     1996_Fran_long_ww3_??_??_96_16_00.snp \
#     1996_Fran_long_ww3_??_??_96_20_00.snp \
)
cd $origdir
#set filename = Fran_long_09_05_96_00_00.snp
set datafile = $datadir/$filename

#set psfile = hbl.snp.ps
set psfile = $filename.ps
set title = $filename

# draw the coast for our grid
# pscoast -R-90/-40/10/50 -JM9i -K -G70 -Dl -Wthinnest \
#     -B5f1:."$title": \
# 	-U"HBL Winds for Ophelia" >! $psfile
pscoast  -R-85/-65/20/40 -JM6i -K -G70 -Dl -Wthinnest \
    -B5f1:."$title": \
	-U"HBL Winds for Ophelia" >! $psfile



# convert data to grd file format
# first create the input file w/ just x,y,z
# note that HBL lists data as lat/lon so we have to reverse it
gawk '{print $2,$1,$6}' $datafile >! xyz.dat
xyz2grd xyz.dat -Gvx.grd -R -I1.0 -V 
gawk '{print $2,$1,$7}' $datafile >! xyz.dat
xyz2grd xyz.dat -Gvy.grd -R -I1.0 -V 


# create grid contours for the magnitude of the wind
gawk '{print $2,$1,sqrt($6*$6+$7*$7)}' $datafile >! xyz.dat
xyz2grd xyz.dat -Gvmag.grd -R -I1.0 -V 
grdcontour vmag.grd -J -C2 -A4 -O -K -S4 -Wthick/255/0/0 >> $psfile


# now  do vector plot
# color (w/ -G can be gray scale (single number) or r/g/b or other)
grdvector vx.grd vy.grd -R -G0/0/255 -J -O -S40i -Q0.03i/0.12i/0.05i >> $psfile

\rm -f .gmt*

end # end of foreach
